package cn.ibizlab.businesscentral.core.product.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.businesscentral.core.product.domain.ProductPricePevel;
import cn.ibizlab.businesscentral.core.product.filter.ProductPricePevelSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[ProductPricePevel] 服务对象接口
 */
public interface IProductPricePevelService extends IService<ProductPricePevel>{

    boolean create(ProductPricePevel et) ;
    void createBatch(List<ProductPricePevel> list) ;
    ProductPricePevel get(String key) ;
    boolean save(ProductPricePevel et) ;
    void saveBatch(List<ProductPricePevel> list) ;
    boolean update(ProductPricePevel et) ;
    void updateBatch(List<ProductPricePevel> list) ;
    ProductPricePevel getDraft(ProductPricePevel et) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean checkKey(ProductPricePevel et) ;
    Page<ProductPricePevel> searchDefault(ProductPricePevelSearchContext context) ;
    List<ProductPricePevel> selectByDiscounttypeid(String discounttypeid) ;
    void removeByDiscounttypeid(String discounttypeid) ;
    List<ProductPricePevel> selectByPricelevelid(String pricelevelid) ;
    void removeByPricelevelid(String pricelevelid) ;
    List<ProductPricePevel> selectByProductid(String productid) ;
    void removeByProductid(String productid) ;
    List<ProductPricePevel> selectByTransactioncurrencyid(String transactioncurrencyid) ;
    void removeByTransactioncurrencyid(String transactioncurrencyid) ;
    List<ProductPricePevel> selectByUomscheduleid(String uomscheduleid) ;
    void removeByUomscheduleid(String uomscheduleid) ;
    List<ProductPricePevel> selectByUomid(String uomid) ;
    void removeByUomid(String uomid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<ProductPricePevel> getProductpricepevelByIds(List<String> ids) ;
    List<ProductPricePevel> getProductpricepevelByEntities(List<ProductPricePevel> entities) ;

}


